// see https://github.com/CreateJS/EaselJS/pull/979

var StageGL = createjs.StageGL;

createjs.StageGL.prototype._appendToBatch = function (container, concatMtx, concatAlpha, ignoreCache) {
  var gl = this._webGLContext;

  // sort out shared properties
  var cMtx = container._glMtx;
  cMtx.copy(concatMtx);
  if (container.transformMatrix !== null) {
    cMtx.appendMatrix(container.transformMatrix);
  } else {
    cMtx.appendTransform(
      container.x, container.y,
      container.scaleX, container.scaleY,
      container.rotation, container.skewX, container.skewY,
      container.regX, container.regY
    );
  }

  var previousRenderMode = this._renderMode;
  if (container.compositeOperation) {
    this._updateRenderMode(container.compositeOperation);
  }

  // sub components of figuring out the position an object holds
  var subL, subT, subR, subB;

  // actually apply its data to the buffers
  var l = container.children.length;
  for (var i = 0; i < l; i++) {
    var item = container.children[i];
    var useCache = (!ignoreCache && item.cacheCanvas) || false;

    if (!(item.visible && concatAlpha > 0.0035)) { continue; }
    var itemAlpha = item.alpha;

    if (useCache === false) {
      if (item._updateState){
        item._updateState();
      }

      if(!this._directDraw && (!ignoreCache && item.cacheCanvas === null && item.filters !== null && item.filters.length)) {
        let bounds;
        if (item.bitmapCache === null) {
          bounds = item.getBounds();
          item.bitmapCache = new createjs.BitmapCache();
          item.bitmapCache._autoGenerated = true;
        }
        if (item.bitmapCache._autoGenerated) {
          this.batchReason = "cachelessFilterInterupt";
          this._renderBatch();					// <----------------------------------------------------

          item.alpha = 1;
          var shaderBackup = this._activeShader;
          bounds = bounds || item.getBounds();
          item.bitmapCache.define(item, bounds.x, bounds.y, bounds.width, bounds.height, 1, {useGL:this});
          useCache = item.bitmapCache._cacheCanvas;

          item.alpha = itemAlpha;
          this._activeShader = shaderBackup;
          gl.bindFramebuffer(gl.FRAMEBUFFER, this._batchTextureOutput._frameBuffer);
        }
      }
    }

    if (useCache === false && item.children) {
      this._appendToBatch(item, cMtx, itemAlpha * concatAlpha);
      continue;
    }

    var containerRenderMode = this._renderMode;
    if (item.compositeOperation) {
      this._updateRenderMode(item.compositeOperation);
    }

    // check for overflowing batch, if yes then force a render
    if (this._batchVertexCount + StageGL.INDICIES_PER_CARD > this._maxBatchVertexCount) {
      this.batchReason = "vertexOverflow";
      this._renderBatch();					// <------------------------------------------------------------
    }

    // keep track of concatenated position
    var iMtx = item._glMtx;
    iMtx.copy(cMtx);
    if (item.transformMatrix) {
      iMtx.appendMatrix(item.transformMatrix);
    } else {
      iMtx.appendTransform(
        item.x, item.y,
        item.scaleX, item.scaleY,
        item.rotation, item.skewX, item.skewY,
        item.regX, item.regY
      );
    }

    var uvRect, texIndex, image, frame, texture, src;

    // get the image data, or abort if not present
    // BITMAP / Cached Canvas
    if (item._webGLRenderStyle === 2 || useCache !== false) {
      image = useCache === false ? item.image : useCache;

    // SPRITE
    } else if (item._webGLRenderStyle === 1) {
      frame = item.spriteSheet.getFrame(item.currentFrame);
      if (frame === null) { continue; }
      image = frame.image;

    // MISC (DOM objects render themselves later)
    } else {
      continue;
    }
    if (!image) { continue; }

    var uvs = this._uvs;
    var vertices = this._vertices;
    var texI = this._indices;
    var alphas = this._alphas;

    // calculate texture
    if (image._storeID === undefined) {
      // this texture is new to us so load it and add it to the batch
      texture = this._loadTextureImage(gl, image);
    } else {
      // fetch the texture (render textures know how to look themselves up to simplify this logic)
      texture = this._textureDictionary[image._storeID];

      if (!texture){ //TODO: this should really not occur but has due to bugs, hopefully this can be removed eventually
        if (this.vocalDebug){ console.log("Image source should not be lookup a non existent texture, please report a bug."); }
        continue;
      }

      // put it in the batch if needed
      if (texture._batchID !== this._batchID) {
        this._insertTextureInBatch(gl, texture);
      }
    }
    texIndex = texture._activeIndex;
    image._drawID = this._drawID;

    // BITMAP / Cached Canvas
    if (item._webGLRenderStyle === 2 || useCache !== false) {
      if (useCache === false && item.sourceRect) {
        // calculate uvs
        if (!item._uvRect) { item._uvRect = {}; }
        src = item.sourceRect;
        uvRect = item._uvRect;
        uvRect.t = 1 - ((src.y)/image.height);
        uvRect.l = (src.x)/image.width;
        uvRect.b = 1 - ((src.y + src.height)/image.height);
        uvRect.r = (src.x + src.width)/image.width;

        // calculate vertices
        subL = 0;							subT = 0;
        subR = src.width+subL;				subB = src.height+subT;
      } else {
        // calculate uvs
        uvRect = StageGL.UV_RECT;
        // calculate vertices
        if (useCache === false) {
          subL = 0;						subT = 0;
          subR = image.width+subL;		subB = image.height+subT;
        } else {
          src = item.bitmapCache;
          subL = src.x+(src._filterOffX/src.scale);	subT = src.y+(src._filterOffY/src.scale);
          subR = (src._drawWidth/src.scale)+subL;		subB = (src._drawHeight/src.scale)+subT;
        }
      }

    // SPRITE
    } else if (item._webGLRenderStyle === 1) {
      var rect = frame.rect;

      // calculate uvs
      uvRect = frame.uvRect;
      if (!uvRect) {
        uvRect = StageGL.buildUVRects(item.spriteSheet, item.currentFrame, false);
      }

      // calculate vertices
      subL = -frame.regX;								subT = -frame.regY;
      subR = rect.width-frame.regX;					subB = rect.height-frame.regY;
    }

    // These must be calculated here else a forced draw might happen after they're set
    var offV1 = this._batchVertexCount;					// offset for 1 component vectors
    var offV2 = offV1*2;								// offset for 2 component vectors

    //DHG: See Matrix2D.transformPoint for why this math specifically
    // apply vertices
    vertices[offV2] =		subL *iMtx.a + subT *iMtx.c +iMtx.tx;		vertices[offV2+1] =		subL *iMtx.b + subT *iMtx.d +iMtx.ty;
    vertices[offV2+2] =		subL *iMtx.a + subB *iMtx.c +iMtx.tx;		vertices[offV2+3] =		subL *iMtx.b + subB *iMtx.d +iMtx.ty;
    vertices[offV2+4] =		subR *iMtx.a + subT *iMtx.c +iMtx.tx;		vertices[offV2+5] =		subR *iMtx.b + subT *iMtx.d +iMtx.ty;
    vertices[offV2+6] =		vertices[offV2+2];							vertices[offV2+7] =		vertices[offV2+3];
    vertices[offV2+8] =		vertices[offV2+4];							vertices[offV2+9] =		vertices[offV2+5];
    vertices[offV2+10] =	subR *iMtx.a + subB *iMtx.c +iMtx.tx;		vertices[offV2+11] =	subR *iMtx.b + subB *iMtx.d +iMtx.ty;

    // apply uvs
    uvs[offV2] =	uvRect.l;			uvs[offV2+1] =	uvRect.t;
    uvs[offV2+2] =	uvRect.l;			uvs[offV2+3] =	uvRect.b;
    uvs[offV2+4] =	uvRect.r;			uvs[offV2+5] =	uvRect.t;
    uvs[offV2+6] =	uvRect.l;			uvs[offV2+7] =	uvRect.b;
    uvs[offV2+8] =	uvRect.r;			uvs[offV2+9] =	uvRect.t;
    uvs[offV2+10] =	uvRect.r;			uvs[offV2+11] =	uvRect.b;

    // apply texture
    texI[offV1] = texI[offV1+1] = texI[offV1+2] = texI[offV1+3] = texI[offV1+4] = texI[offV1+5] = texIndex;

    // apply alpha
    alphas[offV1] = alphas[offV1+1] = alphas[offV1+2] = alphas[offV1+3] = alphas[offV1+4] = alphas[offV1+5] = itemAlpha * concatAlpha;

    this._batchVertexCount += StageGL.INDICIES_PER_CARD;

    if (this._immediateRender) {
      this._immediateBatchRender();
    }

    if (this._renderMode !== containerRenderMode) {
      this._updateRenderMode(containerRenderMode);
    }
  }

  if (this._renderMode !== previousRenderMode) {
    this._updateRenderMode(previousRenderMode);
  }
};